#ifndef __DISPLAY__H__
#define __DISPLAY__H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <ogc/tpl.h>

#include "textures_tpl.h"
#include "textures.h"

#define SCREEN_WIDTH ( 640 )
#define SCREEN_HEIGHT ( 480 )

void display_init();

// must be called every frame, before drawing anything
void display_preFrame();
// must be called every frame, after the scene has been drawn
void display_postFrame();

// draws a rectangular section of a texture onto a quad
void display_draw( f32 x, f32 y, f32 width, f32 height,
				   f32 texLeft, f32 texTop, f32 texRight, f32 texBottom );
// draws a texture onto a quad
void display_draw_full( f32 x, f32 y, f32 width, f32 height );

#endif