/*
 *    Groundhog Puzzle
 *          by Sebastian Mihai, 2015
 *          http://sebastianmihai.com
 *
 * A simple "fifteen puzzle". Use d-pad to move, and Start to reset
 */
#include "utilities.h"
#include "display.h"
#include "board.h"

void p_systemInit() {
	display_init();
	utilities_texturesInit();
	utilities_inputInit();
}

void p_handleInput() {
	
	utilities_inputRead();
	
	if( utilities_inputIsTapped( PAD_BUTTON_START ) ) {
		board_init();
	}
	
	if( !board_hasWon() ) {
		if( utilities_inputIsTapped( PAD_BUTTON_UP ) ) {
			board_move( Up );
		} else if( utilities_inputIsTapped( PAD_BUTTON_DOWN ) ) {
			board_move( Down );
		} else if( utilities_inputIsTapped( PAD_BUTTON_LEFT ) ) {
			board_move( Left );
		} else if( utilities_inputIsTapped( PAD_BUTTON_RIGHT ) ) {
			board_move( Right );
		}
	}
}

int main( int argc, char** argv ) {
	srand( time( NULL ) );
	p_systemInit();
	board_init();
	
	while( 1 ) {
		display_preFrame();
		board_render();
		display_postFrame();
		p_handleInput();
	}
	
	return 0;
}

